#include <stdlib.h>
#include <gtk/gtk.h>

typedef struct
{
    const gchar *nombre2;
    const gchar *talent;
}castal;

enum
{
    COLUMN_NUMBER2,
    COLUMN_TAL,
    NUM_COLUMNS
};

static castal data[] =
{
    {"00", "Corps a corps"},
    {"01", "Bombes seulement"},
    {"02", "Boomrang seulement"},
    {"03", "CaC et bombes"},
    {"04", "CaC et boomrang"},
    {"05", "Boomrang et bombes"},
    {"06", "N'attaque pas"},
};

static GtkTreeModel* creer_model(void)
{
  gint i = 0;
  GtkListStore *store;
  GtkTreeIter iter;

  /* create list store */
  store = gtk_list_store_new (NUM_COLUMNS,
			      G_TYPE_STRING,
			      G_TYPE_STRING);

  /* add data to the list store */
  for (i = 0; i < G_N_ELEMENTS (data); i++)
    {
      gtk_list_store_append (store, &iter);
      gtk_list_store_set (store, &iter,
			  COLUMN_NUMBER2, data[i].nombre2,
			  COLUMN_TAL, data[i].talent,
			  -1);
    }

  return GTK_TREE_MODEL (store);
}

static void add_colonne(GtkTreeView *treeview)
{
    GtkCellRenderer *renderer = NULL;
    GtkTreeViewColumn *colonne = NULL;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));


    //Colonne nombre
    renderer = gtk_cell_renderer_text_new();
    colonne = gtk_tree_view_column_new_with_attributes("Code", renderer, "text", COLUMN_NUMBER2, NULL);

    gtk_tree_view_column_set_sort_column_id(colonne, COLUMN_NUMBER2);
    gtk_tree_view_append_column(treeview, colonne);


    //Colonne temperament
    renderer = gtk_cell_renderer_text_new();
    colonne = gtk_tree_view_column_new_with_attributes("Attaque", renderer, "text", COLUMN_TAL, NULL);

    gtk_tree_view_column_set_sort_column_id(colonne, COLUMN_TAL);
    gtk_tree_view_append_column(treeview, colonne);

}

GtkWidget *fattaque(GtkWidget* widget)
{
    GtkWidget *vbox = NULL;
    GtkWidget *ftalent = NULL;
    GtkWidget *label = NULL;
    GtkWidget *scroll = NULL;
    GtkTreeModel *model = NULL;
    GtkWidget *treeview = NULL;
    GtkWidget *button = NULL;
    GtkWidget *hbox = NULL;

    //Creation de la fenetre
    ftalent = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_screen(GTK_WINDOW(ftalent), gtk_widget_get_screen(widget));
    gtk_window_set_title(GTK_WINDOW(ftalent), "Attaque");
    gtk_window_set_default_size(GTK_WINDOW(ftalent), 480, 272);
    g_signal_connect(ftalent, "destroy", G_CALLBACK(gtk_widget_destroyed), &ftalent);
    gtk_container_set_border_width(GTK_CONTAINER(ftalent), 8);

    vbox = gtk_vbox_new(FALSE, 8);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(ftalent), vbox);

    label = gtk_label_new("Voici la liste de tous les types d'attaques:");
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
    button = gtk_button_new_with_label("Valider");

    //Creation de la barre de scroll
    scroll = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scroll), GTK_SHADOW_ETCHED_IN);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

    gtk_box_pack_start(GTK_BOX(vbox), scroll, TRUE, TRUE, 0);

    //Creer le model
    model = creer_model();

    //Creer la liste
    treeview = gtk_tree_view_new_with_model(model);
    gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(treeview), TRUE);
    gtk_tree_view_set_search_column(GTK_TREE_VIEW(treeview), COLUMN_NUMBER2);
    gtk_tree_view_set_search_column(GTK_TREE_VIEW(treeview), COLUMN_TAL);

    g_object_unref(model);

    gtk_container_add(GTK_CONTAINER(scroll), treeview);

    //Ajout des colonnes a la liste
    add_colonne(GTK_TREE_VIEW(treeview));

     gtk_window_set_modal(GTK_WINDOW(ftalent), TRUE);

    if (!GTK_WIDGET_VISIBLE(ftalent))
    {
        gtk_widget_show_all(ftalent);
    }
    else
    {
        gtk_widget_destroy(ftalent);
        ftalent = NULL;
    }

    return ftalent;

}
